function [U_opt, q_opt, t_s_opt, treateds_opt] = find_optimal_over_time_alloc(B, N_0, N_1, T, alpha_0, beta_0)
    U_opt = 0;

    for t_s = 1: T - 1
        for k_1 = 0: 2
            for q_c = 0: 2^(T - 1) - 1
                q_b = dec2bin(q_c, T - 1) - '0';
                q_b(t_s) = q_b(t_s) + 1;
                q_cs = cumsum([k_1, q_b]);
                q = @(t) q_cs(t);

                % Simulate assuming full treatment at t_s
                treateds_1 = simulate_traj(1, [N_0, N_1, zeros(1, T - 1)], q, T, alpha_0, beta_0);
                E_max = (q(1) == 0)*N_1 + sum(treateds_1);

                % Simulate assuming no treatment at t_s
                Ntilde_0_s = zeros(1, T + 1);
                Ntilde_0_s(q(t_s) + 1) = treateds_1(t_s);
                treateds_2 = simulate_traj(t_s, Ntilde_0_s, @(t) q(t) + 1*(t == t_s), T, alpha_0, beta_0);
                dE = treateds_1(t_s) - sum(treateds_2);

                rho = (E_max - B)/dE;
                if (rho > 1) || (rho < 0)
                    continue
                end

                % Calc. total util
                U = 0;
                treateds = zeros(1, T);
                for t = 1: T
                    v_k_t = value_at_k_t(q(t), t, T, alpha_0, beta_0);
                    if t == t_s
                        treateds(t) = (1 - rho)*treateds_1(t);
                    else
                        treateds(t) = (treateds_1(t) + rho*treateds_2(t));
                    end
                    U = U + treateds(t)*v_k_t;
                end
                treateds(1) = treateds(1) + (q(1) == 0)*N_1;
                U = U + (q(1) == 0)*N_1*value_at_k_t(1, 1, T, alpha_0, beta_0);

                fprintf('\n\n')
                t_s
                q_cs
                U

                % Check for optimality
                if U > U_opt
                    U_opt = U;
                    q_opt = q;
                    t_s_opt = t_s;
                    treateds_opt = treateds;
                end
            end
        end
    end
end
