function treateds = simulate_traj(t_0, N_0_s, q, T, alpha_0, beta_0)
% T > t_0
    Ns = zeros(T + 3, T);
    Nbars = zeros(T + 1, T);
    Ns(1:T + 1, t_0) = N_0_s;

    treateds = zeros(1, T);

    treateds(t_0) = Ns(q(t_0) + 1, t_0);
    for t = t_0 + 1: T
        for k = 0: t
            Nbars(k + 1, t - 1) = Ns(k + 1, t - 1) * (q(t - 1) > k);
            if k > 0
                Nbars(k, t - 1) = Ns(k, t - 1) * (q(t - 1) > k - 1);
            end

            [alpha_k, beta_k] = posterior_at_k_t(k, t - 1, alpha_0, beta_0);
            [alpha_km1, beta_km1] = posterior_at_k_t(k - 1, t - 1, alpha_0, beta_0);

            E_k = beta_k*(beta_k + 1)/(alpha_k + beta_k)/(alpha_k + beta_k + 1);
            E_km1 = alpha_km1*beta_km1/(alpha_km1 + beta_km1)/(alpha_km1 + beta_km1 + 1);

            if k == 0
                Ns(k + 1, t) = Nbars(k + 1, t - 1) * E_k;
            else
                Ns(k + 1, t) = Nbars(k + 1, t - 1) * E_k + Nbars(k, t - 1) * E_km1;
            end
        end

        treateds(t) = Ns(q(t) + 1, t);
    end
end